"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const check_roles_1 = require("./check-roles");
const role_reflection_token_1 = require("./role-reflection-token");
function createRolesGuard(getRole) {
    var _a;
    return _a = class RolesGuard {
            constructor(reflector) {
                this.reflector = reflector;
            }
            canActivate(context) {
                const requiredRoles = this.reflector.getAllAndOverride(role_reflection_token_1.roleReflectionToken, [context.getHandler(), context.getClass()]);
                // roles are not set - handler is allowed for all
                if (!requiredRoles) {
                    return true;
                }
                const role = getRole(context);
                return check_roles_1.checkRoles(requiredRoles, role);
            }
        },
        _a.Params = (...allowedRoles) => common_1.SetMetadata(role_reflection_token_1.roleReflectionToken, allowedRoles),
        _a;
}
exports.createRolesGuard = createRolesGuard;
//# sourceMappingURL=index.js.map